;NiCad Lader

	LIST   P=PIC16F870

	#include	<P16f870.INC>

	__CONFIG       _CP_OFF & _LVP_OFF & _PWRTE_ON & _WDT_ON & _HS_OSC


cnt0	equ	0x22		;telle register
cnt1	equ	0x25
cnt2	equ	0x26
var1	equ	0x27
var2	equ	0x28		;variabel for spenningsjekk
sph	equ	0x29		;variabel for spenningsjekk
spt	equ	0x2a		;variabel for spenningsjekk
sva	equ	0x2b		;variabel for spenningsjekk


	clrf	porta
	clrf	portb
	clrf	portc

;---------------------------------------------------------------------
	bsf	status,5		;bank 1
	bcf	status,6

	movlw	b'11111111'	;setter porta til inngang 
	movwf	trisa
	movlw	b'11111111'	;etter  portc til inngang
	movwf	trisc
	movlw	b'00000000'	;setter portb til utgang
	movwf	trisb		

	movlw	b'10001110'
	movwf	adcon1

	bcf	status,5		;bank 0
;---------------------------------------------------------------------
	movlw	b'10000001'	;Setter register for analog inngang
	movwf	adcon0
	

	bcf	status,2		;clear Z flagg
	bsf	option_reg,0	;Aktiverer watch dog timer
	bsf	option_reg,1	;Setter prescaler
	bsf	option_reg,2	;Setter prescaler
	bsf	option_reg,3	;Setter prescaler



;----- Start -----------------------------
start1
	call	wait
	clrf	portb			;Stopper lading og utlading, slukker LED lamper
	bcf	var1,0
	bcf	var1,1
	bcf	var1,2

start2

	clrwdt
les
	btfss	portc,1			;leser bryter 1
	goto	l2
	btfsc	portc,2
	goto	start1
	btfsc	var1,1
	goto	l2
	goto	lad
l2
	btfss	portc,2			;leser bryter 2
	goto	l3
	btfsc	portc,1
	goto	start1
	btfsc	var1,0
	goto	l3
	goto	utlad
l3
	btfsc	var1,0
	goto	lad
	btfsc	var1,1
	goto	utlad
	btfsc	var1,2
	goto	vlad
	goto	start2

;------ Lader batteriet -------------------
lad
	clrwdt
	bsf	var1,0			;Starter Lading
	bsf	portb,3			;Tenner LED for lading
	bsf	portb,0
	
	btfsc	portc,1	
	goto	lad

	goto	spe			;Sjekker ladespenning
					

;----- Vedlikeholdslading -----------------

vlad	
	bcf	var1,0
	bcf	var1,1
	bsf	var1,2
	
	bsf	portb,4			;tenner LED

	bsf	portb,0			;Starter Lading
	bsf	portb,3			;Tenner LED for lading

	call	wait
	call	wait
	call	wait


	bcf	portb,0			;Stopper Lading
	bcf	portb,3			;Slukker LED for lading

	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	call	wait
	goto	start2




;------ Utlader batteriet -------------------
utlad
	
	bsf	portb,2			;Starter utlading
	bsf	portb,1			;Tenner LED for utlading
	bsf	var1,1
	
	btfsc	portc,2			;Sjekker om utlad bryter holdes nede
	goto	start2			

	btfss	portc,3			;Sjekker om utladingen er ferdig
	goto	start2
	
	clrf	portb			;stopper utlading og slukker LED
	call 	wait
	call	wait
	bcf	var1,1
	goto	utlad2			;Starter lading
	goto	start2

utlad2
	bsf	portb,0			;Starter Lading
	bsf	portb,3			;Tenner LED for lading
	clrf	sph	
	call	wait
	call	wait
	call	wait
	call	wait
	goto	lad


;------ Rutine som sjekker ladespenning -----------
spe
	call	wait
	call	wait

	bsf	adcon0,2		;Tar en prve av spenningen
spa	btfsc	adcon0,2		;Venter p at prven blir tatt
	goto	spa	

	bsf	status,5		;Bank 1
	movfw	adresl			;Flytter adresl til w
	bcf	status,5		;Bank 0

	movwf	spt			;Gjr om til 8 bit fjerner 2 minste bit
	rrf	spt,1
	rrf	spt,1

	bcf	spt,7
	bcf	spt,6
	
	btfsc	adresh,1
	bsf	spt,7
	btfsc	adresh,0
	bsf	spt,6

	movfw	spt
	subwf	sph,w			;w = sph - spt
	movwf	sva 			;legger svaret i sva

	btfsc	status,2
	goto	spe11			;spenningen er lik

	btfss	status,0
	goto	spe11			;spenningen ker

	movlw	.2
	subwf	sva,w			; w = sva - 2
	
	btfss	status,0	
	goto	start2			;spenningen minker med 1
	clrf	sph			;spenningen minker med 2

	goto 	vlad			;gr til vedlikeholdslading

spe11
	movfw	spt			;legger test verdi i sph register
	movwf	sph
	goto	start2


;------ Rutine som venter i 0,5 sek --------

wait
	clrwdt
	movlw	.3
	movwf	cnt2
loop2
	movlw	.255
	movwf	cnt1
loop1
	movlw	.255
	movwf	cnt0
loop0
	decfsz	cnt0
	goto	loop0
	decfsz	cnt1
	goto	loop1
	decfsz	cnt2
	goto	loop2
	
	return	

	
	END
